/*
 * Copyright (c) 2003-2007 Erez Zadok
 * Copyright (c) 2003-2007 Stony Brook University
 * Copyright (c) 2003-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 * Copyright (c) 2003-2005 Akshat Aranya
 * Copyright (c) 2006-2007 Gopala Surya
 */

#ifndef __CONTEXT_HASH_H
#define __CONTEXT_HASH_H

#include "tracereader.h"
#include "messages.h"

#define DEBUG_LOCATION 0

#if DEBUG_LOCATION
#define print_entry_location() fprintf(stderr,"DEBUG: ENTERING: %s, %s:%d\n",__FUNCTION__,__FILE__,__LINE__)
#define print_exit_location() fprintf(stderr,"DEBUG: EXITING: %s, %s:%d\n",__FUNCTION__,__FILE__,__LINE__)
#else
#define print_entry_location()
#define print_exit_location()
#endif

#define print_error(STR) fprintf(stderr,"ERROR: %s (%s, %s:%d)\n",STR,__FUNCTION__,__FILE__,__LINE__)
#define print_error_nomem() print_error("Malloc Failed: Out of Memory")

int context_hash_init();
int context_hash_add(int id,int op,void* context); //Returns 0 if success
void* context_hash_remove(int id,int op); //returns context address, NULL if failed
inline int context_hash_cleanup(); //Deallocate the data structure

#endif //__CONTEXT_HASH_H
