/*
 * Copyright (c) 2003-2007 Erez Zadok
 * Copyright (c) 2003-2007 Stony Brook University
 * Copyright (c) 2003-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 * Copyright (c) 2003-2005 Akshat Aranya
 * Copyright (c) 2006-2007 Gopala Surya
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package, or get one from ftp://ftp.filesystems.org/pub/fist/COPYING.
 *
 * This Copyright notice must be kept intact and distributed with all
 * fistgen sources INCLUDING sources generated by fistgen.
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <errno.h>
#include <string.h>
#include "gengraph.h"
#include "confparser.h"
#include "common.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>


struct user_output_driver *gen_socket_destination(char *hostname, int port, int buf)
{
	struct user_output_driver *dest;
	struct sockaddr_in sin;
	int sockfd;

  	debug("gen_socket_destination called: %s\n", hostname);

	bzero(&sin, sizeof(sin));
	sin.sin_family = AF_INET;
	inet_aton(hostname, &(sin.sin_addr));
	sin.sin_port = htons(port);
	if ((sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0)
		return NULL;

	if (connect(sockfd, (struct sockaddr *)&sin, sizeof(sin)) < 0) {
		close(sockfd);
		return NULL;
	}

	dest = (struct user_output_driver *)malloc(sizeof(struct user_output_driver));
	if (!dest) {
		errno = ENOMEM;
		return NULL;
	}

	dest->od_type = OD_FILE;
	dest->u.od_file.name = NULL;
	dest->u.od_file.buf_size = buf;
	dest->u.od_file.fd = sockfd;

	return dest;
}

